#pragma semicolon 1

#include <sourcemod>
#include <throwing_knives_core>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Throwing Knives]",
	author	= "wS",
	version = "1.0.2"
};

#define ITEM_NAME "throwing_knives"
new g_Knives[MAXPLAYERS + 1];

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	LoadTranslations("vip_modules_description.phrases");
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_Knives[client])
	{
		IntToString(g_Knives[client], ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client, StringToInt(ItemValue));
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue);
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	g_Knives[client] = 0;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH])
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
										
	new knives = StringToInt(ItemValue);
	if (knives < 1)
		return VGA_BadValue;

	if (knives == g_Knives[client])
		return VGA_SameValue;
	
	g_Knives[client] = knives;
	
	IntToString(knives, ItemValue, ITEM_INFO_LENGTH);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, ItemValue, 16);

	return VGA_Continue;
}

///////////////////////////////////////////////////////////////////////////////////

public OnClientDisconnect(client)
	g_Knives[client] = 0;

public Action:TKC_OnKnifesGiven(client, &iCount, by_who)
{
	iCount = g_Knives[client] > 0 ? g_Knives[client] : 0;
	return Plugin_Changed;
}

//

new bool:g_ARENA_Exist;
native bool:KA_ClientOnArena(client);

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	MarkNativeAsOptional("KA_ClientOnArena");
	return APLRes_Success;
}

public OnAllPluginsLoaded() { g_ARENA_Exist = LibraryExists("knife_arena"); }
public OnLibraryRemoved(const String:name[])  { if (!strcmp(name, "knife_arena")) g_ARENA_Exist = false; }
public OnLibraryAdded(const String:name[]) { if (!strcmp(name, "knife_arena")) g_ARENA_Exist = true; }
public bool:TKC_OnKnifeThrow(client) return !g_ARENA_Exist || !KA_ClientOnArena(client);